
(* File: NameMap.i3                                            *)
(* Last modified on Fri Nov  6 16:30:21 MET 1992 by preschern  *)

INTERFACE NameMap;

IMPORT List;

TYPE T <: ROOT;

PROCEDURE New (dir: TEXT := ".") : T;

PROCEDURE Exists (map: T) : BOOLEAN;

PROCEDURE ReadNameMap (map: T);

PROCEDURE WriteNameMap (map: T);

PROCEDURE EnterInMap (map: T; name: TEXT): BOOLEAN;

PROCEDURE EnterUntruncated (map: T; name: TEXT): BOOLEAN;

PROCEDURE RemoveFromMap (map: T; name: TEXT): BOOLEAN;

PROCEDURE GetMapping (map: T; name: TEXT; VAR value: TEXT) : BOOLEAN;

PROCEDURE GetDir (map: T) : TEXT;

PROCEDURE ToList (map: T): List.T;

PROCEDURE Lookup (name: TEXT): TEXT;

PROCEDURE Lookdown (name: TEXT): TEXT;

PROCEDURE Delete (name: TEXT): BOOLEAN;

END NameMap.

