UNSAFE MODULE sn EXPORTS Main;

IMPORT Wr, Stdio, Text, Params, MyDir, List, NameMap, Thread, Unix, M3toC,
       FileStream, Rd;

<* FATAL Rd.Failure, Rd.EndOfFile, Wr.Failure, Thread.Alerted *>

PROCEDURE NotCycleDir (name: TEXT) : BOOLEAN =
  BEGIN
    RETURN NOT Text.Equal (name, ".") AND NOT Text.Equal (name, "..");
  END NotCycleDir;

PROCEDURE OpenDir (name: TEXT) : List.T =
  VAR list: List.T;
  BEGIN
    TRY
      list := MyDir.Contents (name);
    EXCEPT ELSE
      list := NIL;
    END (* try *);
    RETURN list;
  END OpenDir;

PROCEDURE IsTextFile (name: TEXT): BOOLEAN =
  CONST BUFSIZE = 4096;
  VAR buffer: ARRAY [0..BUFSIZE - 1] OF CHAR;
      rd: Rd.T; i, j: INTEGER := 0;
      istext: BOOLEAN := TRUE;
      ch: CHAR;
  BEGIN
    rd := FileStream.OpenRead (name);
    WHILE NOT Rd.EOF (rd) AND (i < BUFSIZE) DO
      buffer [i] := Rd.GetChar (rd); INC (i);
    END (* while *);
    Rd.Close (rd);
    WHILE (j < i) AND istext DO
      ch := buffer [j]; INC (j);
      istext := ((ch >= ' ') AND (ch <= '~')) OR (ch = '\n') OR (ch = '\t'); 
    END (* while *); 
    RETURN istext;
  END IsTextFile;

PROCEDURE MakeDOSTextFile (name, tail: TEXT) = 
  VAR wr: Wr.T; rd: Rd.T;
      tmpname: TEXT := "/tmp/" & tail;
      ch: CHAR;
  BEGIN
    IF Unix.system (M3toC.TtoS ("cp " & name & " " & tmpname)) = 0 THEN
      IF Unix.system (M3toC.TtoS ("rm " & name)) = 0 THEN 
        rd := FileStream.OpenRead (tmpname);
        wr := FileStream.OpenWrite (name);
        WHILE NOT Rd.EOF (rd) DO
          ch := Rd.GetChar (rd);
          IF (ch = '\n') THEN Wr.PutChar (wr, '\r') END (* if *); 
          Wr.PutChar (wr, ch);
        END (* while *); 
        Rd.Close (rd); Wr.Close (wr); 
      END (* if *);
    END (* if *);
    EVAL Unix.system (M3toC.TtoS ("rm " & tmpname));
  END MakeDOSTextFile;

PROCEDURE RenameFiles (map: NameMap.T) =
  VAR oldname, newname, oldtail : TEXT;
      list := NameMap.ToList (map);
      dir  := NameMap.GetDir (map);
  BEGIN
    WHILE (list # NIL) DO
      oldname := List.Pop (list);
      IF NOT NameMap.GetMapping (map, oldname, newname) THEN
        <* ASSERT FALSE *>
      END (* if *);
      oldtail := oldname;
      oldname := dir & "/" & oldname;
      newname := dir & "/" & newname;
      TRY 
        IF DOS_FLAG AND IsTextFile (oldname) THEN
          MakeDOSTextFile (oldname, oldtail);
        END (* if *);
        IF NOT Text.Equal (oldname, newname) THEN
          MyDir.Rename (oldname, newname);
        END (* if *);
        Wr.PutText (Stdio.stdout, oldname & " mapped to " & newname & "\n");
        Wr.Flush (Stdio.stdout);
      EXCEPT ELSE
        Wr.PutText(Stdio.stdout, "Sorry, directory error in " & dir & "\n");
      END (* try *);
    END (* while *);
  END RenameFiles;

PROCEDURE ProcessDir (map: NameMap.T; list: List.T) : BOOLEAN =
  VAR newmap: NameMap.T; 
      newlist: List.T;
      name, dir: TEXT;
  BEGIN
    IF (list = NIL) OR (map = NIL) THEN RETURN FALSE END (* if *); 

    WHILE (list # NIL) DO
      name := List.Pop (list);
      IF NotCycleDir (name) THEN
        dir := NameMap.GetDir (map) & "/" & name;
        (* is it a directory or is it not a directory - this is the question *)
        newlist := OpenDir (dir);

        IF REC_FLAG AND (newlist # NIL) THEN      (* we want it recursively *)
          newmap := NameMap.New (dir);
          IF NOT ProcessDir (newmap, newlist) THEN
            Wr.PutText (Stdio.stdout, "Sorry, cannot process " & dir & "\n");
          END (* if *);
        END (* if *);

        IF (newlist = NIL) THEN                 (* ordinary file *)
          IF NOT NameMap.EnterInMap (map, name) THEN <* ASSERT FALSE *> END;
        ELSE
          IF NOT NameMap.EnterUntruncated (map, name) THEN 
            <* ASSERT FALSE *> 
          END (* if *);
        END (* if *); 
      END (* if *);
    END (* while *);
    RenameFiles (map);           (* rename the files in the directory *)
    NameMap.WriteNameMap (map);  (* create the map in the file system *) 
    RETURN TRUE;
  END ProcessDir;

PROCEDURE ShortNames (dir: TEXT ) =
  VAR map  := NameMap.New (dir);
      list := OpenDir (dir);
  BEGIN 
    IF NOT ProcessDir (map, list) THEN
      Wr.PutText (Stdio.stdout, "Sorry, cannot process " & dir & "\n");
    END (* if *);
  END ShortNames;

PROCEDURE PrintUsage () =
  BEGIN
    Wr.PutText (Stdio.stdout, 
      "usage: "                                                            &
      Params.Get(0)                                                        &
      " directory [-r] [-d]\n"                                             &
      " sn        = a program that creates a NAMES.MAP for a directory \n" &
      " directory = the directory where to perform sn \n"                  &
      " -r        = perform sn recursively on subdirectories \n"           &
      " -d        = convert Unix text files to DOS text files \n");
  END PrintUsage;

VAR
  PARAMSok := TRUE; REC_FLAG, DOS_FLAG := FALSE;

PROCEDURE CheckParam (name: TEXT) =
  BEGIN
    IF Text.Equal (name, "-r") THEN REC_FLAG := TRUE;
    ELSIF Text.Equal (name, "-d") THEN DOS_FLAG := TRUE;
    ELSE
      PARAMSok := FALSE;
    END (* if *);
  END CheckParam;

BEGIN
  IF (Params.Count = 2) THEN
    ShortNames (Params.Get (1));
  ELSIF (Params.Count = 3) OR (Params.Count = 4) THEN
    FOR i := 2 TO Params.Count - 1 DO
      CheckParam (Params.Get (i));
    END (* for *);
    IF PARAMSok THEN ShortNames (Params.Get (1));
    ELSE PrintUsage ();
    END (* if *);
  ELSE
    PrintUsage ();
  END (* if *);
END sn. 
